(function () {
    "use strict";

    angular.module('core').controller('contatoController', controller);
    controller.$inject = ['$scope', '$timeout', 'contatoService'];

    function controller($scope, $timeout, contatoService) {
        $scope.initializeLayout('Contatos');

        //[Inicializa objetos]
        $scope.state = {
            data: [],
            carregando: false,
            vazio: false,
            count: 0,
            filtro: {
                ativo: false,
                args: {
                    chaves: '',
                    filtro: {
                        Ativo: null,
                        CPF: '',
                        Empresa: { Nome: null, CNPJ: '' },
                        IndicaCliente: null,
                        IndicaFornecedor: null,
                        IndicaVendedor: null,
                    },
                    sortExpression: '',
                    skip: 0,
                    take: 20
                }
            },
        };

        //[Inicializa funcões]
        $scope.initialize = function () {
            $scope.refresh();
        };

        $scope.getAll = function () {
            $scope.state.filtro.args.skip = 0;
            $scope.state.carregando = true;
            $scope.state.vazio = false;
            contatoService
                .getAll($scope.state.filtro.args)
                .then(
                    function (response) {
                        if (response.Status < 0) {
                            $scope.tools.toastr.error(response.Message, 'Serviço');
                            console.error(response.Exception);
                        } else {
                            angular.copy(angular.fromJson(response.Data), $scope.state.data);
                        }
                        $scope.state.carregando = false;
                        $scope.state.vazio = ($scope.state.data == 0);
                    },
                    function (_error) {
                        $scope.state.carregando = false;
                        $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                        console.error(_error);
                    }
                );
        };
        $scope.count = function () {
            contatoService
                .count($scope.state.filtro.args)
                .then(
                    function (response) {
                        if (response.Status < 0) {
                            $scope.tools.toastr.error(response.Message, 'Serviço');
                            console.error(response.Exception);
                        } else {
                            $scope.state.count = response.Data;
                        }
                    },
                    function (_error) {
                        $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                        console.error(_error);
                    }
                );
        };
        $scope.getMore = function () {
            $scope.state.filtro.args.skip += $scope.state.filtro.args.take;
            contatoService
                .getAll($scope.state.filtro.args)
                .then(
                    function (response) {
                        if (response.Status < 0) {
                            $scope.tools.toastr.error(response.Message, 'Serviço');
                            console.error(response.Exception);
                        } else {
                            $scope.state.data = $scope.state.data.concat(response.Data);
                        }
                    },
                    function (_error) {
                        $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                        console.error(_error);
                    }
                );
        };
        $scope.refresh = function () {
            $scope.getAll();
            $scope.count();
        };

        $scope.clearFilter = function () {
            $scope.state.filtro.args.chaves = '';
            $scope.state.filtro.args.filtro.Ativo = null;
            $scope.state.filtro.args.filtro.CPF = '';
            $scope.state.filtro.args.filtro.Empresa.CNPJ = '';
            $scope.state.filtro.args.filtro.Empresa.Nome = '';
            $scope.state.filtro.args.filtro.IndicaCliente = null;
            $scope.state.filtro.args.filtro.IndicaFornecedor = null;
            $scope.state.filtro.args.filtro.IndicaVendedor = null;

            $scope.refresh();
        };
        $scope.toggleFilter = function () {
            $scope.state.filtro.ativo = !$scope.state.filtro.ativo;
        };

        /*Inicializa funções*/
        $scope.initialize();

    }

})();